import React, { FC, ReactNode } from 'react';
export type Modal<P> = {
    Component?: FC<P>;
    id: string;
    props?: Partial<P>;
    style?: {
        overrideMaxWidth?: boolean;
        width?: number | string;
    };
    title?: string | ReactNode;
};
export type ModalId = Modal<any>['id'];
export type ModalContextType = {
    close: (modalId: ModalId) => void;
    open: <P>(modalId: ModalId, modal?: Partial<Modal<P>>) => void;
    opened: ModalId[];
    register: <P>(modal: Modal<P>) => void;
    registered: Record<ModalId, Modal<any>>;
    unregister: (modalId: ModalId) => void;
};
export declare const ModalContext: React.Context<ModalContextType>;
export declare const ModalWrapper: FC<{
    children: ReactNode;
}>;
export declare const openModal: (modal: Modal<any>) => void;
export declare const closeModal: (modalId: ModalId) => void;
