"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.closeModal = exports.openModal = exports.ModalWrapper = exports.ModalContext = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
exports.ModalContext = (0, react_1.createContext)({
    registered: {},
    opened: [],
    open: () => { },
    close: () => { },
    register: () => { },
    unregister: () => { },
});
const ModalWrapper = ({ children }) => {
    const [registered, setRegistered] = (0, react_1.useState)({});
    const [opened, setOpened] = (0, react_1.useState)([]);
    const register = function (modal) {
        setRegistered((modals) => (Object.assign(Object.assign({}, modals), { [modal.id]: Object.assign(Object.assign({}, modals[modal.id]), modal) })));
    };
    const unregister = (modalId) => {
        setRegistered((modals) => (0, ramda_1.omit)([modalId], modals));
    };
    const open = function (modalId, modal) {
        if (!registered[modalId]) {
            register(Object.assign(Object.assign({}, modal), { id: modalId }));
        }
        setOpened((opened) => [...opened, modalId]);
    };
    const close = (modalId) => {
        setOpened((opened) => opened.filter((id) => id !== modalId));
    };
    (0, react_1.useEffect)(() => {
        window.addEventListener('openModal', (e) => {
            if (e.detail)
                open(e.detail.id, e.detail);
        });
        window.addEventListener('closeModal', (e) => {
            if (e.detail)
                close(e.detail);
        });
    }, []);
    const value = (0, react_1.useMemo)(() => ({
        registered: registered,
        opened,
        unregister,
        register,
        open,
        close,
    }), [registered, opened]);
    return react_1.default.createElement(exports.ModalContext.Provider, { value: value }, children);
};
exports.ModalWrapper = ModalWrapper;
const openModal = (modal) => {
    window.dispatchEvent(new CustomEvent('openModal', { detail: modal }));
};
exports.openModal = openModal;
const closeModal = (modalId) => {
    window.dispatchEvent(new CustomEvent('closeModal', { detail: modalId }));
};
exports.closeModal = closeModal;
