"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controller = void 0;
const react_1 = __importStar(require("react"));
const date_fns_1 = require("date-fns");
const AngleLeft_1 = require("@procyon/components/Icons/AngleLeft");
const AngleRight_1 = require("@procyon/components/Icons/AngleRight");
const Today_1 = require("@procyon/components/Icons/Today");
const Calendar_1 = require("./Calendar");
const Controller = ({ layout, type, workDate, onNextClick, onPrevClick, onTodayClick }) => {
    const Controller = (0, react_1.useMemo)(() => {
        switch (layout) {
            case Calendar_1.CalendarLayoutEnum.month:
                if (type === Calendar_1.CalendarTypeEnum.months) {
                    return (0, date_fns_1.format)(workDate, 'yyyy');
                }
                return (0, date_fns_1.format)(workDate, 'MM. yyyy');
            case Calendar_1.CalendarLayoutEnum.week:
                return [(0, date_fns_1.format)((0, Calendar_1.getWeekRange)(workDate)[0], 'dd.MM.'), ' - ', (0, date_fns_1.format)((0, Calendar_1.getWeekRange)(workDate)[1], 'dd.MM.yyyy')];
            case Calendar_1.CalendarLayoutEnum.day:
                return (0, date_fns_1.format)(workDate, 'dd.MM.yyyy');
        }
    }, [workDate, layout, type]);
    return (react_1.default.createElement("div", { className: "calendar-controller" },
        react_1.default.createElement("div", { className: "inline-block cursor-pointer pl-2", onClick: onPrevClick },
            react_1.default.createElement(AngleLeft_1.AngleLeftIcon, null)),
        react_1.default.createElement("div", { className: "inline-block px-5" }, Controller),
        react_1.default.createElement("div", { className: "inline-block cursor-pointer pr-4", onClick: onNextClick },
            react_1.default.createElement(AngleRight_1.AngleRightIcon, null)),
        react_1.default.createElement("div", { className: "inline-block cursor-pointer text-md", onClick: onTodayClick },
            react_1.default.createElement(Today_1.TodayIcon, null))));
};
exports.Controller = Controller;
