"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatePicker = exports.DefaultDateFormat = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const date_fns_1 = require("date-fns");
const Today_1 = require("@procyon/components/Icons/Today");
const useModal_1 = require("@procyon/components/Modal/useModal");
const TextField_1 = require("../../TextField");
const DatePickerModal_1 = require("./DatePickerModal");
exports.DefaultDateFormat = 'dd.MM.yyyy';
const DatePicker = (props) => {
    var _a;
    const { onChange, label, name, format } = props, others = __rest(props, ["onChange", "label", "name", "format"]);
    const [openModal, closeModal] = (0, useModal_1.useModal)(name, {
        title: label,
        style: { width: 400 },
    });
    const [value, setValue] = (0, react_1.useState)();
    (0, react_1.useEffect)(() => {
        if (props.value) {
            setValue(props.value);
        }
    }, [props.value]);
    const handleDateClick = (value) => {
        setValue(value);
        onChange === null || onChange === void 0 ? void 0 : onChange(value, null);
    };
    const modalComponent = (0, react_1.useCallback)((props) => (react_1.default.createElement(DatePickerModal_1.DatePickerModal, Object.assign({ format: format !== null && format !== void 0 ? format : exports.DefaultDateFormat, name: name, value: value, closeModal: closeModal, onChange: handleDateClick }, props))), [format, name, value]);
    const handleOpenModal = () => {
        openModal({
            Component: modalComponent,
        });
    };
    return (react_1.default.createElement(TextField_1.TextField, Object.assign({ name: name, label: label, value: value ? (0, date_fns_1.format)(value, (_a = props.format) !== null && _a !== void 0 ? _a : exports.DefaultDateFormat) : undefined }, (0, ramda_1.omit)(['value', 'onClick'], others), { leftIcon: react_1.default.createElement(Today_1.TodayIcon, { onClick: handleOpenModal, className: "field-icon" }), placeholder: format !== null && format !== void 0 ? format : exports.DefaultDateFormat })));
};
exports.DatePicker = DatePicker;
