import React, { FC, MouseEvent } from 'react';
import { InputElementType } from '@procyon/types/form';
import { Option } from '@procyon/types/options';
export type OptionViewProps = {
    icons?: {
        [key: Option['code']]: React.ReactNode;
    };
};
export type InnerOptionsProps = {
    onClick: (code: Option['code'], e: MouseEvent<HTMLDivElement>) => void;
    option: Option;
    value: Option['code'] | null;
};
export type RadioButtonProps<V = Option['code']> = Omit<{
    View?: FC<OptionViewProps & InnerOptionsProps>;
    horizontal?: boolean;
    options: Option[];
    responsive?: boolean;
} & InputElementType<V>, 'onFocus' | 'onBlur' | 'onChange' | 'disabled'>;
export declare const RadioButton: React.FC<RadioButtonProps>;
